#!/usr/bin/env ruby
# encoding: utf-8

module Coopy
  class CombinedTableHead 
    
    def initialize(parent,dx,dy)
      @parent = parent
      @dx = dx
      @dy = dy
      @all = parent.all
    end
    
    protected
    
    attr_accessor :parent
    attr_accessor :dx
    attr_accessor :dy
    attr_accessor :all
    
    public
    
    def get_table 
      self
    end
    
    def height() get_height end
    def height=(__v) @height = __v end
    def width() get_width end
    def width=(__v) @width = __v end
    
    def get_width 
      @all.get_width
    end
    
    def get_height 
      @dy
    end
    
    def get_cell(x,y)
      if x == 0 
        v = self.get_cell_view
        txt = v.to_s(@all.get_cell(x,y))
        return txt[1,txt.length] if txt[0] == "@"
      end
      @all.get_cell(x,y)
    end
    
    def set_cell(x,y,c)
      @all.set_cell(x,y,c)
    end
    
    def to_s 
      ::Coopy::SimpleTable.table_to_string(self)
    end
    
    def get_cell_view 
      @all.get_cell_view
    end
    
    def is_resizable 
      false
    end
    
    def resize(w,h)
      false
    end
    
    def clear 
    end
    
    def insert_or_delete_rows(fate,hfate)
      false
    end
    
    def insert_or_delete_columns(fate,wfate)
      @all.insert_or_delete_columns(fate,wfate)
    end
    
    def trim_blank 
      false
    end
    
    def get_data 
      nil
    end
    
    def clone 
      nil
    end
    
    def create 
      nil
    end
    
    def get_meta 
      nil
    end
    
  haxe_me ["coopy", "CombinedTableHead"]
  end

end
