#!/usr/bin/env ruby
# encoding: utf-8

module Coopy
  class JsonTable 
    
    def initialize(data,name)
      @data = data
      @columns = Reflect.field(data,"columns")
      @rows = Reflect.field(data,"rows")
      @w = @columns.length
      @h = @rows.length
      @idx2col = {}
      begin
        _g1 = 0
        _g = @columns.length
        while(_g1 < _g) 
          idx = _g1
          _g1+=1
          begin
            v = @columns[idx]
            @idx2col[idx] = v
            v
          end
        end
      end
      @name = name
    end
    
    protected
    
    attr_accessor :w
    attr_accessor :h
    attr_accessor :columns
    attr_accessor :rows
    attr_accessor :data
    attr_accessor :idx2col
    attr_accessor :name
    
    public
    
    def get_table 
      self
    end
    
    def height() get_height end
    def height=(__v) @height = __v end
    def width() get_width end
    def width=(__v) @width = __v end
    
    def get_width 
      @w
    end
    
    def get_height 
      @h + 1
    end
    
    def get_cell(x,y)
      return @idx2col[x] if y == 0
      Reflect.field(@rows[y - 1],@idx2col[x])
    end
    
    def set_cell(x,y,c)
      puts "JsonTable is read-only"
    end
    
    def to_s 
      ""
    end
    
    def get_cell_view 
      ::Coopy::SimpleView.new
    end
    
    def is_resizable 
      false
    end
    
    def resize(w,h)
      false
    end
    
    def clear 
    end
    
    def insert_or_delete_rows(fate,hfate)
      false
    end
    
    def insert_or_delete_columns(fate,wfate)
      false
    end
    
    def trim_blank 
      false
    end
    
    def get_data 
      nil
    end
    
    def clone 
      nil
    end
    
    def set_meta(meta)
    end
    
    def get_meta 
      self
    end
    
    def create 
      nil
    end
    
    def alter_columns(columns)
      false
    end
    
    def change_row(rc)
      false
    end
    
    def apply_flags(flags)
      false
    end
    
    def as_table 
      nil
    end
    
    def clone_meta(table = nil)
      nil
    end
    
    def use_for_column_changes 
      false
    end
    
    def use_for_row_changes 
      false
    end
    
    def get_row_stream 
      nil
    end
    
    def is_nested 
      false
    end
    
    def is_sql 
      false
    end
    
    def get_name 
      @name
    end
    
  haxe_me ["coopy", "JsonTable"]
  end

end
