#!/usr/bin/env ruby
# encoding: utf-8

module Coopy
  class JsonTables 
    
    def initialize(json,flags)
      @db = json
      names = Reflect.field(json,"names")
      allowed = nil
      count = names.length
      if flags != nil && flags.tables != nil 
        allowed = {}
        begin
          _g = 0
          _g1 = flags.tables
          while(_g < _g1.length) 
            name = _g1[_g]
            _g+=1
            allowed[name] = true
          end
        end
        count = 0
        begin
          _g2 = 0
          while(_g2 < names.length) 
            name1 = names[_g2]
            _g2+=1
            count+=1 if allowed.include?(name1)
          end
        end
      end
      @t = ::Coopy::SimpleTable.new(2,count + 1)
      @t.set_cell(0,0,"name")
      @t.set_cell(1,0,"table")
      v = @t.get_cell_view
      at = 1
      begin
        _g3 = 0
        while(_g3 < names.length) 
          name2 = names[_g3]
          _g3+=1
          if allowed != nil 
            next if !allowed.include?(name2)
          end
          @t.set_cell(0,at,name2)
          tab = Reflect.field(@db,"tables")
          tab = Reflect.field(tab,name2)
          @t.set_cell(1,at,v.wrap_table(::Coopy::JsonTable.new(tab,name2)))
          at+=1
        end
      end
    end
    
    protected
    
    attr_accessor :db
    attr_accessor :t
    attr_accessor :flags
    
    public
    
    def height() get_height end
    def height=(__v) @height = __v end
    def width() get_width end
    def width=(__v) @width = __v end
    
    def get_cell(x,y)
      @t.get_cell(x,y)
    end
    
    def set_cell(x,y,c)
    end
    
    def get_cell_view 
      @t.get_cell_view
    end
    
    def is_resizable 
      false
    end
    
    def resize(w,h)
      false
    end
    
    def clear 
    end
    
    def insert_or_delete_rows(fate,hfate)
      false
    end
    
    def insert_or_delete_columns(fate,wfate)
      false
    end
    
    def trim_blank 
      false
    end
    
    def get_width 
      @t.get_width
    end
    
    def get_height 
      @t.get_height
    end
    
    def get_data 
      nil
    end
    
    def clone 
      nil
    end
    
    def get_meta 
      ::Coopy::SimpleMeta.new(self,true,true)
    end
    
    def create 
      nil
    end
    
  haxe_me ["coopy", "JsonTables"]
  end

end
