#!/usr/bin/env ruby
# encoding: utf-8

module Coopy
  class TableIO 
    
    def initialize
    end
    
    def valid 
      true
    end
    
    def get_content(name)
      ::Sys::Io::HxFile.get_content(name)
    end
    
    def save_content(name,txt)
      ::Sys::Io::HxFile.save_content(name,txt)
      true
    end
    
    def args 
      HxSys.args
    end
    
    def write_stdout(txt)
      HxSys.stdout.write_string(txt)
    end
    
    def write_stderr(txt)
      HxSys.stderr.write_string(txt)
    end
    
    def command(cmd,args)
      begin
        return HxSys.command(cmd,args)
      rescue => e
        e = hx_rescued(e)
        return 1
      end
    end
    
    def async 
      false
    end
    
    def exists(path)
      File.exist?(path)
    end
    
    def is_tty_known 
      false
    end
    
    def is_tty 
      return true if HxSys.get_env("GIT_PAGER_IN_USE") == "true"
      false
    end
    
    def open_sqlite_database(path)
      nil
    end
    
    def send_to_browser(html)
      puts "do not know how to send to browser in this language"
    end
    
  haxe_me ["coopy", "TableIO"]
  end

end
