#!/usr/bin/env ruby
# encoding: utf-8

module Coopy
  class Tables 
    
    def initialize(template)
      @template = template
      @tables = {}
      @table_order = Array.new
    end
    
    protected
    
    attr_accessor :template
    attr_accessor :tables
    attr_accessor :table_order
    
    public
    
    attr_accessor :alignment
    
    def add(name)
      t = @template.clone
      @tables[name] = t
      @table_order.push(name)
      t
    end
    
    def get_order 
      @table_order
    end
    
    def get(name)
      @tables[name]
    end
    
    def one 
      @tables[@table_order[0]]
    end
    
    def has_ins_del 
      return false if @alignment == nil
      return true if @alignment.has_addition
      return true if @alignment.has_removal
      false
    end
    
  haxe_me ["coopy", "Tables"]
  end

end
